# ZOYbp[

package segwrapper;

use Time::Local;
use Time::JulianDay;
use Fcntl;


$TSFOLDER = "D:\\TS";

sub DateTimeToFullPath {
	my $Base = shift;
	my $Ch   = shift;
	my $tm   = shift;
	my $y,$m,$d,$h,$n,$s,$str,$datstr;
	($s,$n,$h,$d,$m,$y) = localtime($tm);
	$str = sprintf("%02d%02d%02d%02d",$y % 100,$m+1,$d,$h);
	$datstr = sprintf("%02d%02d%02d",$y % 100,$m+1,$d);
	return ($Base."\\".$datstr."\\".$str."_Ch".($Ch+0));
}


sub HourFileExists {
	my $Base = shift;
	my $Ch   = shift;
	my $tm   = shift;
	if (-f &DateTimeToFullPath($Base,$Ch,$tm).".idx") {
		1;
	} else {
		0;
	}
}

sub TOTtoDateTime {
	my $totcode = shift;
	my $mjd,$y,$m,$d,$h,$n,$s,$ch,$cn,$cs;
	($mjd,$ch,$cn,$cs) = unpack("nCCC",$totcode);
	($y,$m,$d) = inverse_julian_day($mjd+2400000.5+1); # @@@ +1?
	$h = (($ch >> 4) & 0x0F) * 10 + ($ch & 0x0F);
	$n = (($cn >> 4) & 0x0F) * 10 + ($cn & 0x0F);
	$s = (($cs >> 4) & 0x0F) * 10 + ($cs & 0x0F);
	return timelocal($s,$n,$h,$d,$m-1,$y);
}

sub segopen {
	my	$fn		= $_[1];
	my	%para	= ();
	my	$dt,$st,$ed,$channel;
	my	$dt_y,$dt_m,$dt_d;
	my	$st_h,$st_m,$st_s;
	my	$ed_h,$ed_m,$ed_s;
	my	$err,$no_ed;
	my	$st_t,$ed_t;
	my	$LastTime,$LastPos,$NextTime,$hourcnt;
	my	$IdxFH,$IdxSize;
	my	$totcode,$posicode,$posi,$IdxTime;
	my	$contsize;
	my	@filestart,@fileend,@filetime,@filepos;

	# ̉
	$fn =~ s/^\/+//;
	($dt,$st,$ed,$channel) = split("-",$fn);
	$err	= 0;
	$no_ed	= 0;
	#
	if ($channel eq "") {
		$channel = $ed;
		$ed = "";
	}
	if ($dt =~ /^(\d\d)(\d\d)(\d\d)$/) {
		$dt_y	= ($1)+0;
		$dt_m	= ($2)+0;
		$dt_d	= ($3)+0;
	} else {
		$err	= 1;
	}
	if ($st =~ /^(\d\d)(\d\d)(\d\d)$/) {
		$st_h	= ($1)+0;
		$st_m	= ($2)+0;
		$st_s	= ($3)+0;
	} else {
		$err	= 1;
	}
	if ($ed =~ /^(\d\d)(\d\d)(\d\d)$/) {
		$ed_h	= ($1)+0;
		$ed_m	= ($2)+0;
		$ed_s	= ($3)+0;
	} else {
		$no_ed	= 1;
	}
	#
	if ($err == 0) {
		$st_t = timelocal($st_s,$st_m,$st_h,$dt_d,$dt_m-1,$dt_y+2000);
		if ($no_ed == 0) {
			$ed_t = timelocal($ed_s,$ed_m,$ed_h,$dt_d,$dt_m-1,$dt_y+2000);
			if ($ed_t<$st_t) {
				$ed_t = $ed_t + 24*3600;
			}
		} else {
			$ed_t = $st_t + 3600*2;
		}
		$param{"Start"} = $st_t;
		$param{"End"}   = $ed_t;


		# --------------------------------
		#   Jnn_
		# --------------------------------
		# 1ԑO猟
		$LastTime = $st_t-3600;
		$LastPos  = 0;
		$hourcnt  = 2;
		if (!&HourFileExists($TSFOLDER,$channel,$LastTime)) {
			# OԂ̃t@CȂ瓖00b
			$LastTime = timelocal(0,0,0,$dt_d,$dt_m-1,$dt_y+2000);
			$LastPos  = 0;
			$hourcnt  = 1;
		}
	
		# Jn_̘^t@CI
		if (!&HourFileExists($TSFOLDER,$channel,$LastTime)) {
			print "[WARN] No TS File\n";
			# @@@G[
			return;
		}

		# JnԃCfbNX
		$NextTime = $LastTime;
		while($hourcnt>0) {
			sysopen($IdxFH,&DateTimeToFullPath($TSFOLDER,$channel,$NextTime).".idx",O_RDONLY);
			$IdxSize = sysseek($IdxFH,0,2);
			sysseek($IdxFH,0,0);
			while ((sysseek($IdxFH,0,1)<$IdxSize) && ($hourcnt>0)) {
				sysread($IdxFH,$totcode,5);
				sysread($IdxFH,$posicode,4);		# ZO
				$posi = unpack("L",$posicode);		# ZO
				$IdxTime = &TOTtoDateTime($totcode);
				if ($param{"Start"}>$IdxTime) {
					$LastTime = $IdxTime;
					$LastPos  = $posi;
				} else {
					$hourcnt = 0;
					break;
				}
			}
			if ($hourcnt>0) {
				my ($s,$n,$h,$d,$m,$y) = localtime($NextTime+3600);
				$NextTime = timelocal(0,0,$h,$d,$m,$y);
				$hourcnt = $hourcnt - 1;
			}
			close($IdxFH);
		}
		$param{"StartTime"} = $LastTime;
		$param{"StartPos"}  = $LastPos;

		# --------------------------------
		#   In_
		# --------------------------------
		# IԃCfbNX
		$hourcnt = 24;
		$NextTime = $LastTime;
		while($hourcnt>0) {
			sysopen($IdxFH,&DateTimeToFullPath($TSFOLDER,$channel,$NextTime).".idx",O_RDONLY);
			$IdxSize = sysseek($IdxFH,0,2);
			sysseek($IdxFH,0,0);
			while ((sysseek($IdxFH,0,1)<$IdxSize) && ($hourcnt>0)) {
				sysread($IdxFH,$totcode,5);
				sysread($IdxFH,$posicode,4);		# ZO
				$posi = unpack("L",$posicode);		# ZO
				$IdxTime = &TOTtoDateTime($totcode);
				if ($param{"End"}>$IdxTime) {
					$LastTime = $IdxTime;
					$LastPos  = $posi;
				} else {
					$LastTime = $IdxTime;		# IԂ߂܂
					$LastPos  = $posi;
					$hourcnt  = 0;
					break;
				}
			}
			if ($hourcnt>0) {
				my ($s,$n,$h,$d,$m,$y) = localtime($NextTime+3600);
				$NextTime = timelocal(0,0,$h,$d,$m,$y);
				$hourcnt = $hourcnt - 1;
			}
			close($IdxFH);
		}
		$param{"EndTime"} = $LastTime;
		$param{"EndPos"}  = $LastPos;
	}

	# --------------------------------
	#   t@CTCY
	# --------------------------------
	$contsize = 0;
	$LastTime = $param{"StartTime"};
	$LastPos  = $param{"StartPos"};
	$param{"CurrentLast"} = -1;
	@filestart = ();
	@fileend   = ();
	@filetime  = ();
	@filepos   = ();
	sysopen($IdxFH,&DateTimeToFullPath($TSFOLDER,$channel,$LastTime).".ts",O_RDONLY);
	$IdxSize = sysseek($IdxFH,0,2);
	sysseek($IdxFH,$LastPos,0);
	while ($LastTime<$param{"EndTime"}) {
		if (&DateTimeToFullPath($TSFOLDER,$channel,$LastTime) eq &DateTimeToFullPath($TSFOLDER,$channel,$param{"EndTime"})) {
			# Ō̃t@C
			push @filestart, $contsize;
			push @fileend  , $contsize + $param{"EndPos"} - $LastPos;
			push @filetime , $LastTime;
			push @filepos  , $LastPos;
			$contsize = $contsize + $param{"EndPos"} - $LastPos;
			$LastTime = $param{"EndTime"};
			if ($param{"CurrentLast"}<0) {
				$param{"CurrentLast"} = $param{"EndPos"};
			}
		} else {
			# rt@C
			push @filestart, $contsize;
			push @fileend  , $contsize + ($IdxSize - $LastPos);
			push @filetime , $LastTime;
			push @filepos  , $LastPos;
			$contsize = $contsize + ($IdxSize - $LastPos);
			if ($param{"CurrentLast"}<0) {
				$param{"CurrentLast"} = $IdxSize;
			}
			# ̎
			my ($s,$n,$h,$d,$m,$y) = localtime($LastTime+3600);
			$LastTime = timelocal(0,0,$h,$d,$m,$y);
			$LastPos  = 0;
			if (&HourFileExists($TSFOLDER,$channel,$LastTime)) {
				close($IdxFH);
				sysopen($IdxFH,&DateTimeToFullPath($TSFOLDER,$channel,$LastTime).".ts",O_RDONLY);
				$IdxSize = sysseek($IdxFH,0,2);
				sysseek($IdxFH,$LastPos,0);
			} else {
				# ̃t@ĈŏI
				$LastTime = $param{"EndTime"};
			}
		}
	}
	$param{"Size"} = $contsize;
	$param{"filestart"} = \@filestart;
	$param{"fileend"}   = \@fileend;
	$param{"filetime"}  = \@filetime;
	$param{"filepos"}   = \@filepos;
	$param{"Channel"}   = $channel;
	$param{"OpenMode"}  = $_[2];
	$_[0] = \%param;
	$param{"CurrentTime"} = -1;
	segseek($_[0],0,0);
}

sub segseek {
	my $pos,$i,$ptr;
	my @filestart,@fileend,@filetime,@filepos;
	@filestart = @{$_[0]{"filestart"}};
	@fileend   = @{$_[0]{"fileend"}};
	@filetime  = @{$_[0]{"filetime"}};
	@filepos   = @{$_[0]{"filepos"}};

	# 擪̈ʒům
	if ($_[2]==0) {
		# start
		$pos = $_[1];
	} elsif ($_[2]==1) {
		# current
		$ptr = -1;
		for($i=0;$i<=$#filetime;$i++) {
			if ($filetime[$i] == $_[0]{"CurrentTime"}) {
				$ptr = $i;
			}
		}
		if ($ptr<0) {
			$pos = $_[1];
		} else {
			$pos = sysseek($_[0]{"FileHandle"},0,1);
			$pos = $pos - $filepos[$ptr] + $filestart[$ptr] + $_[1];
		}
	} else {
		# end
		$pos = $_[0]{"Size"} + $_[1];
	}

	# t@Cƃt@Cʒům
	$ptr = -1;
	for($i=0;$i<=$#filestart;$i++) {
		if ($filestart[$i] <= $pos) {
			$ptr = $i;
		}
	}
	if ($ptr<0) { return 0; }
	
	# t@CύXꂽJȂ
	if ($filetime[$ptr] != $_[0]{"CurrentTime"}) {
		close($_[0]{"FileHandle"});
		$_[0]{"FileHandle"} = "";
		sysopen($_[0]{"FileHandle"}, &DateTimeToFullPath($TSFOLDER,$_[0]{"Channel"},$filetime[$ptr]).".ts", $_[0]{"OpenMode"});
		$_[0]{"CurrentTime"} = $filetime[$ptr];
		$_[0]{"CurrentLast"} = $filepos[$ptr]+($fileend[$ptr]-$filestart[$ptr]);
	}
	
	# Seek
	sysseek($_[0]{"FileHandle"}, $pos-$filestart[$ptr]+$filepos[$ptr], 0);
	return $pos;
}

sub segread {
	my $pos,$size;

	$size = 0;
	$pos = sysseek($_[0]{"FileHandle"},0,1);
	if ($pos<$_[0]{"CurrentLast"}) {
		$size = sysread($_[0]{"FileHandle"}, $_[1], $_[2]);
	} else {
		$pos = segseek($_[0],0,1);
		if ($pos<$_[0]{"Size"}) {
			$size = sysread($_[0]{"FileHandle"}, $_[1], $_[2]);
		}
	}
	return $size;
}

sub segclose {
	close($_[0]{"FileHandle"});
}

1;
